diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/applications/model/onoff-application.h ns-3.31/src/applications/model/onoff-application.h
--- ns-3.30.1/src/applications/model/onoff-application.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/applications/model/onoff-application.h	2020-06-27 17:38:30.000000000 -0700
@@ -31,6 +31,7 @@
 #include "ns3/ptr.h"
 #include "ns3/data-rate.h"
 #include "ns3/traced-callback.h"
+#include "ns3/seq-ts-size-header.h"
 
 namespace ns3 {
 
@@ -82,6 +83,14 @@
 *
 * If the underlying socket type supports broadcast, this application
 * will automatically enable the SetAllowBroadcast(true) socket option.
+*
+ * If the attribute "EnableSeqTsSizeHeader" is enabled, the application will
+ * use some bytes of the payload to store an header with a sequence number,
+ * a timestamp, and the size of the packet sent. Support for extracting 
+ * statistics from this header have been added to \c ns3::PacketSink 
+ * (enable its "EnableSeqTsSizeHeader" attribute), or users may extract
+ * the header via trace sources.  Note that the continuity of the sequence
+ * number may be disrupted across On/Off cycles.
 */
 class OnOffApplication : public Application 
 {
@@ -150,6 +159,7 @@
 
   Ptr<Socket>     m_socket;       //!< Associated socket
   Address         m_peer;         //!< Peer address
+  Address         m_local;        //!< Local address to bind to
   bool            m_connected;    //!< True if connected
   Ptr<RandomVariableStream>  m_onTime;       //!< rng for On Time
   Ptr<RandomVariableStream>  m_offTime;      //!< rng for Off Time
@@ -163,6 +173,10 @@
   EventId         m_startStopEvent;     //!< Event id for next start or stop event
   EventId         m_sendEvent;    //!< Event id of pending "send packet" event
   TypeId          m_tid;          //!< Type of the socket used
+  uint32_t        m_seq {0};      //!< Sequence
+  Ptr<Packet>     m_unsentPacket; //!< Unsent packet cached for future attempt
+  bool            m_enableSeqTsSizeHeader {false}; //!< Enable or disable the use of SeqTsSizeHeader
+
 
   /// Traced Callback: transmitted packets.
   TracedCallback<Ptr<const Packet> > m_txTrace;
@@ -170,6 +184,9 @@
   /// Callbacks for tracing the packet Tx events, includes source and destination addresses
   TracedCallback<Ptr<const Packet>, const Address &, const Address &> m_txTraceWithAddresses;
 
+  /// Callback for tracing the packet Tx events, includes source, destination, the packet sent, and header
+  TracedCallback<Ptr<const Packet>, const Address &, const Address &, const SeqTsSizeHeader &> m_txTraceWithSeqTsSize;
+
 private:
   /**
    * \brief Schedule the next packet transmission
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/applications/model/packet-sink.cc ns-3.31/src/applications/model/packet-sink.cc
--- ns-3.30.1/src/applications/model/packet-sink.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/applications/model/packet-sink.cc	2020-06-27 17:38:30.000000000 -0700
@@ -31,6 +31,7 @@
 #include "ns3/trace-source-accessor.h"
 #include "ns3/udp-socket-factory.h"
 #include "packet-sink.h"
+#include "ns3/boolean.h"
 
 namespace ns3 {
 
@@ -55,6 +56,11 @@
                    TypeIdValue (UdpSocketFactory::GetTypeId ()),
                    MakeTypeIdAccessor (&PacketSink::m_tid),
                    MakeTypeIdChecker ())
+    .AddAttribute ("EnableSeqTsSizeHeader",
+                   "Enable optional header tracing of SeqTsSizeHeader",
+                   BooleanValue (false),
+                   MakeBooleanAccessor (&PacketSink::m_enableSeqTsSizeHeader),
+                   MakeBooleanChecker ())
     .AddTraceSource ("Rx",
                      "A packet has been received",
                      MakeTraceSourceAccessor (&PacketSink::m_rxTrace),
@@ -62,6 +68,10 @@
     .AddTraceSource ("RxWithAddresses", "A packet has been received",
                      MakeTraceSourceAccessor (&PacketSink::m_rxTraceWithAddresses),
                      "ns3::Packet::TwoAddressTracedCallback")
+    .AddTraceSource ("RxWithSeqTsSize",
+                     "A packet with SeqTsSize header has been received",
+                     MakeTraceSourceAccessor (&PacketSink::m_rxTraceWithSeqTsSize),
+                     "ns3::PacketSink::SeqTsSizeCallback")
   ;
   return tid;
 }
@@ -197,9 +207,53 @@
       socket->GetSockName (localAddress);
       m_rxTrace (packet, from);
       m_rxTraceWithAddresses (packet, from, localAddress);
+
+      if (m_enableSeqTsSizeHeader)
+        {
+          PacketReceived (packet, from, localAddress);
+        }
     }
 }
 
+void
+PacketSink::PacketReceived (const Ptr<Packet> &p, const Address &from,
+                            const Address &localAddress)
+{
+  SeqTsSizeHeader header;
+  Ptr<Packet> buffer;
+
+  auto itBuffer = m_buffer.find (from);
+  if (itBuffer == m_buffer.end ())
+    {
+      itBuffer = m_buffer.insert (std::make_pair (from, Create<Packet> (0))).first;
+    }
+
+  buffer = itBuffer->second;
+  buffer->AddAtEnd (p);
+  buffer->PeekHeader (header);
+
+  NS_ABORT_IF (header.GetSize () == 0);
+
+  while (buffer->GetSize () >= header.GetSize ())
+    {
+      NS_LOG_DEBUG ("Removing packet of size " << header.GetSize () << " from buffer of size " << buffer->GetSize ());
+      Ptr<Packet> complete = buffer->CreateFragment (0, static_cast<uint32_t> (header.GetSize ()));
+      buffer->RemoveAtStart (static_cast<uint32_t> (header.GetSize ()));
+
+      complete->RemoveHeader (header);
+
+      m_rxTraceWithSeqTsSize (complete, from, localAddress, header);
+
+      if (buffer->GetSize () > header.GetSerializedSize ())
+        {
+          buffer->PeekHeader (header);
+        }
+      else
+        {
+          break;
+        }
+    }
+}
 
 void PacketSink::HandlePeerClose (Ptr<Socket> socket)
 {
@@ -210,7 +264,6 @@
 {
   NS_LOG_FUNCTION (this << socket);
 }
- 
 
 void PacketSink::HandleAccept (Ptr<Socket> s, const Address& from)
 {
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/applications/model/packet-sink.h ns-3.31/src/applications/model/packet-sink.h
--- ns-3.30.1/src/applications/model/packet-sink.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/applications/model/packet-sink.h	2020-06-27 17:38:30.000000000 -0700
@@ -26,6 +26,9 @@
 #include "ns3/ptr.h"
 #include "ns3/traced-callback.h"
 #include "ns3/address.h"
+#include "ns3/inet-socket-address.h"
+#include "ns3/seq-ts-size-header.h"
+#include <unordered_map>
 
 namespace ns3 {
 
@@ -91,7 +94,18 @@
    * \return list of pointers to accepted sockets
    */
   std::list<Ptr<Socket> > GetAcceptedSockets (void) const;
- 
+
+  /**
+   * TracedCallback signature for a reception with addresses and SeqTsSizeHeader
+   *
+   * \param p The packet received (without the SeqTsSize header)
+   * \param from From address
+   * \param to Local address
+   * \param header The SeqTsSize header
+   */
+  typedef void (* SeqTsSizeCallback)(Ptr<const Packet> p, const Address &from, const Address & to,
+                                   const SeqTsSizeHeader &header);
+
 protected:
   virtual void DoDispose (void);
 private:
@@ -121,7 +135,43 @@
    */
   void HandlePeerError (Ptr<Socket> socket);
 
-  // In the case of TCP, each socket accept returns a new socket, so the 
+  /**
+   * \brief Packet received: assemble byte stream to extract SeqTsSizeHeader
+   * \param p received packet
+   * \param from from address
+   * \param localAddress local address
+   *
+   * The method assembles a received byte stream and extracts SeqTsSizeHeader
+   * instances from the stream to export in a trace source.
+   */
+  void PacketReceived (const Ptr<Packet> &p, const Address &from, const Address &localAddress);
+
+  /**
+   * \brief Hashing for the Address class
+   */
+  struct AddressHash
+  {
+    /**
+     * \brief operator ()
+     * \param x the address of which calculate the hash
+     * \return the hash of x
+     *
+     * Should this method go in address.h?
+     *
+     * It calculates the hash taking the uint32_t hash value of the ipv4 address.
+     * It works only for InetSocketAddresses (Ipv4 version)
+     */
+    size_t operator() (const Address &x) const
+    {
+      NS_ABORT_IF (!InetSocketAddress::IsMatchingType (x));
+      InetSocketAddress a = InetSocketAddress::ConvertFrom (x);
+      return std::hash<uint32_t>()(a.GetIpv4 ().Get ());
+    }
+  };
+
+  std::unordered_map<Address, Ptr<Packet>, AddressHash> m_buffer; //!< Buffer for received packets
+
+  // In the case of TCP, each socket accept returns a new socket, so the
   // listening socket is stored separately from the accepted sockets
   Ptr<Socket>     m_socket;       //!< Listening socket
   std::list<Ptr<Socket> > m_socketList; //!< the accepted sockets
@@ -130,12 +180,14 @@
   uint64_t        m_totalRx;      //!< Total bytes received
   TypeId          m_tid;          //!< Protocol TypeId
 
+  bool            m_enableSeqTsSizeHeader {false}; //!< Enable or disable the export of SeqTsSize header 
+
   /// Traced Callback: received packets, source address.
   TracedCallback<Ptr<const Packet>, const Address &> m_rxTrace;
-
   /// Callback for tracing the packet Rx events, includes source and destination addresses
   TracedCallback<Ptr<const Packet>, const Address &, const Address &> m_rxTraceWithAddresses;
-
+  /// Callbacks for tracing the packet Rx events, includes source, destination addresses, and headers
+  TracedCallback<Ptr<const Packet>, const Address &, const Address &, const SeqTsSizeHeader&> m_rxTraceWithSeqTsSize;
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/applications/model/seq-ts-echo-header.cc ns-3.31/src/applications/model/seq-ts-echo-header.cc
--- ns-3.30.1/src/applications/model/seq-ts-echo-header.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/applications/model/seq-ts-echo-header.cc	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,136 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2009 INRIA
+ * Copyright (c) 2016 Universita' di Firenze (added echo fields)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Tommaso Pecorella <tommaso.pecorella@unifi.it>
+ */
+
+#include "ns3/assert.h"
+#include "ns3/log.h"
+#include "ns3/header.h"
+#include "ns3/simulator.h"
+#include "seq-ts-echo-header.h"
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("SeqTsEchoHeader");
+
+NS_OBJECT_ENSURE_REGISTERED (SeqTsEchoHeader);
+
+SeqTsEchoHeader::SeqTsEchoHeader ()
+  : m_seq (0),
+    m_tsValue (Simulator::Now ()),
+    m_tsEchoReply (Seconds (0))
+{
+  NS_LOG_FUNCTION (this);
+}
+
+void
+SeqTsEchoHeader::SetSeq (uint32_t seq)
+{
+  NS_LOG_FUNCTION (this << seq);
+  m_seq = seq;
+}
+
+uint32_t
+SeqTsEchoHeader::GetSeq (void) const
+{
+  NS_LOG_FUNCTION (this);
+  return m_seq;
+}
+
+void
+SeqTsEchoHeader::SetTsValue (Time ts)
+{
+  NS_LOG_FUNCTION (this << ts);
+  m_tsValue = ts;
+}
+
+Time
+SeqTsEchoHeader::GetTsValue (void) const
+{
+  NS_LOG_FUNCTION (this);
+  return m_tsValue;
+}
+
+void
+SeqTsEchoHeader::SetTsEchoReply (Time ts)
+{
+  NS_LOG_FUNCTION (this << ts);
+  m_tsEchoReply = ts;
+}
+
+Time
+SeqTsEchoHeader::GetTsEchoReply (void) const
+{
+  NS_LOG_FUNCTION (this);
+  return m_tsEchoReply;
+}
+
+TypeId
+SeqTsEchoHeader::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::SeqTsEchoHeader")
+    .SetParent<Header> ()
+    .SetGroupName ("Applications")
+    .AddConstructor<SeqTsEchoHeader> ()
+  ;
+  return tid;
+}
+
+TypeId
+SeqTsEchoHeader::GetInstanceTypeId (void) const
+{
+  return GetTypeId ();
+}
+
+void
+SeqTsEchoHeader::Print (std::ostream &os) const
+{
+  NS_LOG_FUNCTION (this << &os);
+  os << "(seq=" << m_seq << " Tx time=" << m_tsValue.As (Time::S) << " Rx time=" << m_tsEchoReply.As (Time::S) << ")";
+}
+
+uint32_t
+SeqTsEchoHeader::GetSerializedSize (void) const
+{
+  NS_LOG_FUNCTION (this);
+  return 4+8+8;
+}
+
+void
+SeqTsEchoHeader::Serialize (Buffer::Iterator start) const
+{
+  NS_LOG_FUNCTION (this << &start);
+  Buffer::Iterator i = start;
+  i.WriteHtonU32 (m_seq);
+  i.WriteHtonU64 (m_tsValue.GetTimeStep ());
+  i.WriteHtonU64 (m_tsEchoReply.GetTimeStep ());
+}
+
+uint32_t
+SeqTsEchoHeader::Deserialize (Buffer::Iterator start)
+{
+  NS_LOG_FUNCTION (this << &start);
+  Buffer::Iterator i = start;
+  m_seq = i.ReadNtohU32 ();
+  m_tsValue = TimeStep (i.ReadNtohU64 ());
+  m_tsEchoReply = TimeStep (i.ReadNtohU64 ());
+  return GetSerializedSize ();
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/applications/model/seq-ts-echo-header.h ns-3.31/src/applications/model/seq-ts-echo-header.h
--- ns-3.30.1/src/applications/model/seq-ts-echo-header.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/applications/model/seq-ts-echo-header.h	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,99 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2009 INRIA
+ * Copyright (c) 2016 Universita' di Firenze (added echo fields)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Tommaso Pecorella <tommaso.pecorella@unifi.it>
+ */
+
+#ifndef SEQ_TS_ECHO_HEADER_H
+#define SEQ_TS_ECHO_HEADER_H
+
+#include "ns3/header.h"
+#include "ns3/nstime.h"
+
+namespace ns3 {
+/**
+ * \ingroup applications
+ * \class SeqTsEchoHeader
+ * \brief Packet header to carry sequence number and two timestamps
+ *
+ * The header is made of a 32bits sequence number followed by
+ * two 64bits time stamps (Transmit and Receive).
+ */
+class SeqTsEchoHeader : public Header
+{
+public:
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+
+  /**
+   * \brief constructor
+   */
+  SeqTsEchoHeader ();
+
+  /**
+   * \param seq the sequence number
+   */
+  void SetSeq (uint32_t seq);
+
+  /**
+   * \return the sequence number
+   */
+  uint32_t GetSeq (void) const;
+
+  /**
+   * \return A time value set by the sender
+   */
+  Time GetTsValue (void) const;
+
+  /**
+   * \return A time value echoing the received timestamp
+   */
+  Time GetTsEchoReply (void) const;
+
+  /**
+   * \brief Set the sender's time value
+   * \param ts Time value to set
+   */
+  void SetTsValue (Time ts);
+
+  /**
+   * \brief Upon SeqTsEchoHeader reception, the host answers via echoing
+   * back the received timestamp
+   * \param ts received timestamp. If not called, will contain 0
+   */
+  void SetTsEchoReply (Time ts);
+  
+  // Inherited
+  virtual TypeId GetInstanceTypeId (void) const override;
+  virtual void Print (std::ostream &os) const override;
+  virtual uint32_t GetSerializedSize (void) const override;
+  virtual void Serialize (Buffer::Iterator start) const override;
+  virtual uint32_t Deserialize (Buffer::Iterator start) override;
+
+private:
+  uint32_t m_seq; //!< Sequence number
+  Time m_tsValue; //!< Sender's timestamp
+  Time m_tsEchoReply; //!< Receiver's timestamp
+};
+
+} // namespace ns3
+
+#endif /* SEQ_TS_ECHO_HEADER_H */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/applications/model/seq-ts-header.h ns-3.31/src/applications/model/seq-ts-header.h
--- ns-3.30.1/src/applications/model/seq-ts-header.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/applications/model/seq-ts-header.h	2020-06-27 17:38:30.000000000 -0700
@@ -26,12 +26,20 @@
 
 namespace ns3 {
 /**
- * \ingroup udpclientserver
+ * \ingroup applications
  *
- * \brief Packet header for UDP client/server application.
+ * \brief Packet header to carry sequence number and timestamp
  *
- * The header is made of a 32bits sequence number followed by
- * a 64bits time stamp.
+ * The header is used as a payload in applications (typically UDP) to convey
+ * a 32 bit sequence number followed by a 64 bit timestamp (12 bytes total).
+ *
+ * The timestamp is not set explicitly but automatically set to the
+ * simulation time upon creation.
+ *
+ * If you need space for an application data unit size field (e.g. for 
+ * stream-based protocols like TCP), use ns3::SeqTsSizeHeader.
+ *
+ * \sa ns3::SeqTsSizeHeader
  */
 class SeqTsHeader : public Header
 {
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/applications/model/seq-ts-size-header.cc ns-3.31/src/applications/model/seq-ts-size-header.cc
--- ns-3.30.1/src/applications/model/seq-ts-size-header.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/applications/model/seq-ts-size-header.cc	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,99 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2009 INRIA
+ * Copyright (c) 2018 Natale Patriciello <natale.patriciello@gmail.com>
+ *                    (added timestamp and size fields)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ */
+
+#include "ns3/log.h"
+#include "seq-ts-size-header.h"
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("SeqTsSizeHeader");
+
+NS_OBJECT_ENSURE_REGISTERED (SeqTsSizeHeader);
+
+SeqTsSizeHeader::SeqTsSizeHeader ()
+  : SeqTsHeader ()
+{
+  NS_LOG_FUNCTION (this);
+}
+
+TypeId
+SeqTsSizeHeader::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::SeqTsSizeHeader")
+    .SetParent<SeqTsHeader> ()
+    .SetGroupName ("Applications")
+    .AddConstructor<SeqTsSizeHeader> ()
+  ;
+  return tid;
+}
+
+TypeId
+SeqTsSizeHeader::GetInstanceTypeId (void) const
+{
+  return GetTypeId ();
+}
+
+void
+SeqTsSizeHeader::SetSize (uint64_t size)
+{
+  m_size = size;
+}
+
+uint64_t
+SeqTsSizeHeader::GetSize (void) const
+{
+  return m_size;
+}
+
+void
+SeqTsSizeHeader::Print (std::ostream &os) const
+{
+  NS_LOG_FUNCTION (this << &os);
+  os << "(size=" << m_size << ") AND ";
+  SeqTsHeader::Print (os);
+}
+
+uint32_t
+SeqTsSizeHeader::GetSerializedSize (void) const
+{
+  return SeqTsHeader::GetSerializedSize () + 8;
+}
+
+void
+SeqTsSizeHeader::Serialize (Buffer::Iterator start) const
+{
+  NS_LOG_FUNCTION (this << &start);
+  Buffer::Iterator i = start;
+  i.WriteHtonU64 (m_size);
+  SeqTsHeader::Serialize (i);
+}
+
+uint32_t
+SeqTsSizeHeader::Deserialize (Buffer::Iterator start)
+{
+  NS_LOG_FUNCTION (this << &start);
+  Buffer::Iterator i = start;
+  m_size = i.ReadNtohU64 ();
+  SeqTsHeader::Deserialize (i);
+  return GetSerializedSize ();
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/applications/model/seq-ts-size-header.h ns-3.31/src/applications/model/seq-ts-size-header.h
--- ns-3.30.1/src/applications/model/seq-ts-size-header.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/applications/model/seq-ts-size-header.h	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,76 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+ *   Copyright (c) 2009 INRIA
+ *   Copyright (c) 2018 Natale Patriciello <natale.patriciello@gmail.com>
+ *                      (added timestamp and size fields)
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License version 2 as
+ *   published by the Free Software Foundation;
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+#ifndef SEQ_TS_SIZE_HEADER_H
+#define SEQ_TS_SIZE_HEADER_H
+
+#include <ns3/seq-ts-header.h>
+
+namespace ns3 {
+/**
+ * \ingroup applications
+ * \brief Header with a sequence, a timestamp, and a "size" attribute
+ *
+ * This header adds a size attribute to the sequence number and timestamp
+ * of class \c SeqTsHeader.  The size attribute can be used to track
+ * application data units for stream-based sockets such as TCP.
+ *
+ * \sa ns3::SeqTsHeader
+ */
+class SeqTsSizeHeader : public SeqTsHeader
+{
+public:
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+
+  /**
+   * \brief constructor
+   */
+  SeqTsSizeHeader ();
+
+  /**
+   * \brief Set the size information that the header will carry
+   * \param size the size
+   */
+  void SetSize (uint64_t size);
+
+  /**
+   * \brief Get the size information that the header is carrying
+   * \return the size
+   */
+  uint64_t GetSize (void) const;
+
+  // Inherited
+  virtual TypeId GetInstanceTypeId (void) const override;
+  virtual void Print (std::ostream &os) const override;
+  virtual uint32_t GetSerializedSize (void) const override;
+  virtual void Serialize (Buffer::Iterator start) const override;
+  virtual uint32_t Deserialize (Buffer::Iterator start) override;
+
+private:
+  uint64_t m_size {0}; //!< The 'size' information that the header is carrying
+};
+
+} // namespace ns3
+
+#endif /* SEQ_TS_SIZE_HEADER */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/applications/test/bulk-send-application-test-suite.cc ns-3.31/src/applications/test/bulk-send-application-test-suite.cc
--- ns-3.30.1/src/applications/test/bulk-send-application-test-suite.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/applications/test/bulk-send-application-test-suite.cc	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,233 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Tom Henderson (tomh@tomh.org)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ */
+
+#include "ns3/test.h"
+#include "ns3/nstime.h"
+#include "ns3/node.h"
+#include "ns3/traced-callback.h"
+#include "ns3/node-container.h"
+#include "ns3/application-container.h"
+#include "ns3/simple-net-device-helper.h"
+#include "ns3/string.h"
+#include "ns3/uinteger.h"
+#include "ns3/boolean.h"
+#include "ns3/internet-stack-helper.h"
+#include "ns3/ipv4-address.h"
+#include "ns3/inet-socket-address.h"
+#include "ns3/ipv4-address-helper.h"
+#include "ns3/ipv4-interface-container.h"
+#include "ns3/bulk-send-application.h"
+#include "ns3/bulk-send-helper.h"
+#include "ns3/packet-sink.h"
+#include "ns3/packet-sink-helper.h"
+
+using namespace ns3;
+
+class BulkSendBasicTestCase : public TestCase
+{
+public:
+  BulkSendBasicTestCase ();
+  virtual ~BulkSendBasicTestCase ();
+
+private:
+  virtual void DoRun (void);
+  void SendTx (Ptr<const Packet> p);
+  void ReceiveRx (Ptr<const Packet> p, const Address& addr); 
+  uint64_t m_sent {0};
+  uint64_t m_received {0};
+};
+
+BulkSendBasicTestCase::BulkSendBasicTestCase ()
+  : TestCase ("Check a basic 300KB transfer")
+{
+}
+
+BulkSendBasicTestCase::~BulkSendBasicTestCase ()
+{
+}
+
+void
+BulkSendBasicTestCase::SendTx (Ptr<const Packet> p)
+{
+  m_sent += p->GetSize ();
+}
+
+void
+BulkSendBasicTestCase::ReceiveRx (Ptr<const Packet> p, const Address& addr) 
+{
+  m_received += p->GetSize ();
+}
+
+void
+BulkSendBasicTestCase::DoRun (void)
+{
+  Ptr<Node> sender = CreateObject<Node> ();
+  Ptr<Node> receiver = CreateObject<Node> ();
+  NodeContainer nodes;
+  nodes.Add (sender);
+  nodes.Add (receiver);
+  SimpleNetDeviceHelper simpleHelper;
+  simpleHelper.SetDeviceAttribute ("DataRate", StringValue ("10Mbps"));
+  simpleHelper.SetChannelAttribute ("Delay", StringValue ("10ms"));
+  NetDeviceContainer devices;
+  devices = simpleHelper.Install (nodes);
+  InternetStackHelper internet;
+  internet.Install (nodes);
+  Ipv4AddressHelper ipv4;
+  ipv4.SetBase ("10.1.1.0", "255.255.255.0");
+  Ipv4InterfaceContainer i = ipv4.Assign (devices);
+  uint16_t port = 9;
+  BulkSendHelper sourceHelper ("ns3::TcpSocketFactory",
+                               InetSocketAddress (i.GetAddress (1), port));
+  sourceHelper.SetAttribute ("MaxBytes", UintegerValue (300000));
+  ApplicationContainer sourceApp = sourceHelper.Install (nodes.Get (0));
+  sourceApp.Start (Seconds (0.0));
+  sourceApp.Stop (Seconds (10.0));
+  PacketSinkHelper sinkHelper ("ns3::TcpSocketFactory",
+                         InetSocketAddress (Ipv4Address::GetAny (), port));
+  ApplicationContainer sinkApp = sinkHelper.Install (nodes.Get (1));
+  sinkApp.Start (Seconds (0.0));
+  sinkApp.Stop (Seconds (10.0));
+
+  Ptr<BulkSendApplication> source = DynamicCast<BulkSendApplication> (sourceApp.Get (0));
+  Ptr<PacketSink> sink = DynamicCast<PacketSink> (sinkApp.Get (0));
+
+  source->TraceConnectWithoutContext ("Tx", MakeCallback (&BulkSendBasicTestCase::SendTx, this));
+  sink->TraceConnectWithoutContext ("Rx", MakeCallback (&BulkSendBasicTestCase::ReceiveRx, this));
+
+  Simulator::Run ();
+  Simulator::Destroy ();
+
+  NS_TEST_ASSERT_MSG_EQ (m_sent, 300000, "Sent the full 300000 bytes");
+  NS_TEST_ASSERT_MSG_EQ (m_received, 300000, "Received the full 300000 bytes");
+}
+
+// This test checks that the sequence number is sent and received in sequence
+// despite the sending application having to pause and restart its sending
+// due to a temporarily full transmit buffer.
+class BulkSendSeqTsSizeTestCase : public TestCase
+{
+public:
+  BulkSendSeqTsSizeTestCase ();
+  virtual ~BulkSendSeqTsSizeTestCase ();
+
+private:
+  virtual void DoRun (void);
+  void SendTx (Ptr<const Packet> p, const Address &from, const Address & to, const SeqTsSizeHeader &header);
+  void ReceiveRx (Ptr<const Packet> p, const Address &from, const Address & to, const SeqTsSizeHeader &header);
+  uint64_t m_sent {0};
+  uint64_t m_received {0};
+  uint64_t m_seqTxCounter {0};
+  uint64_t m_seqRxCounter {0};
+  Time m_lastTxTs {Seconds (0)};
+  Time m_lastRxTs {Seconds (0)};
+};
+
+BulkSendSeqTsSizeTestCase::BulkSendSeqTsSizeTestCase ()
+  : TestCase ("Check a 300KB transfer with SeqTsSize header enabled")
+{
+}
+
+BulkSendSeqTsSizeTestCase::~BulkSendSeqTsSizeTestCase ()
+{
+}
+
+void
+BulkSendSeqTsSizeTestCase::SendTx (Ptr<const Packet> p, const Address &from, const Address & to, const SeqTsSizeHeader &header)
+{
+  // The header is not serialized onto the packet in this trace
+  m_sent += p->GetSize () + header.GetSerializedSize ();
+  NS_TEST_ASSERT_MSG_EQ (header.GetSeq (), m_seqTxCounter, "Missing sequence number");
+  m_seqTxCounter++;
+  NS_TEST_ASSERT_MSG_GT_OR_EQ (header.GetTs (), m_lastTxTs, "Timestamp less than last time");
+  m_lastTxTs = header.GetTs ();
+}
+
+void
+BulkSendSeqTsSizeTestCase::ReceiveRx (Ptr<const Packet> p, const Address &from, const Address & to, const SeqTsSizeHeader &header)
+{
+  // The header is not serialized onto the packet in this trace
+  m_received += p->GetSize () + header.GetSerializedSize ();
+  NS_TEST_ASSERT_MSG_EQ (header.GetSeq (), m_seqRxCounter, "Missing sequence number");
+  m_seqRxCounter++;
+  NS_TEST_ASSERT_MSG_GT_OR_EQ (header.GetTs (), m_lastRxTs, "Timestamp less than last time");
+  m_lastRxTs = header.GetTs ();
+}
+
+void
+BulkSendSeqTsSizeTestCase::DoRun (void)
+{
+  Ptr<Node> sender = CreateObject<Node> ();
+  Ptr<Node> receiver = CreateObject<Node> ();
+  NodeContainer nodes;
+  nodes.Add (sender);
+  nodes.Add (receiver);
+  SimpleNetDeviceHelper simpleHelper;
+  simpleHelper.SetDeviceAttribute ("DataRate", StringValue ("10Mbps"));
+  simpleHelper.SetChannelAttribute ("Delay", StringValue ("10ms"));
+  NetDeviceContainer devices;
+  devices = simpleHelper.Install (nodes);
+  InternetStackHelper internet;
+  internet.Install (nodes);
+  Ipv4AddressHelper ipv4;
+  ipv4.SetBase ("10.1.1.0", "255.255.255.0");
+  Ipv4InterfaceContainer i = ipv4.Assign (devices);
+  uint16_t port = 9;
+  BulkSendHelper sourceHelper ("ns3::TcpSocketFactory",
+                               InetSocketAddress (i.GetAddress (1), port));
+  sourceHelper.SetAttribute ("MaxBytes", UintegerValue (300000));
+  sourceHelper.SetAttribute ("EnableSeqTsSizeHeader", BooleanValue (true));
+  ApplicationContainer sourceApp = sourceHelper.Install (nodes.Get (0));
+  sourceApp.Start (Seconds (0.0));
+  sourceApp.Stop (Seconds (10.0));
+  PacketSinkHelper sinkHelper ("ns3::TcpSocketFactory",
+                         InetSocketAddress (Ipv4Address::GetAny (), port));
+  sinkHelper.SetAttribute ("EnableSeqTsSizeHeader", BooleanValue (true));
+  ApplicationContainer sinkApp = sinkHelper.Install (nodes.Get (1));
+  sinkApp.Start (Seconds (0.0));
+  sinkApp.Stop (Seconds (10.0));
+
+  Ptr<BulkSendApplication> source = DynamicCast<BulkSendApplication> (sourceApp.Get (0));
+  Ptr<PacketSink> sink = DynamicCast<PacketSink> (sinkApp.Get (0));
+
+  source->TraceConnectWithoutContext ("TxWithSeqTsSize", MakeCallback (&BulkSendSeqTsSizeTestCase::SendTx, this));
+  sink->TraceConnectWithoutContext ("RxWithSeqTsSize", MakeCallback (&BulkSendSeqTsSizeTestCase::ReceiveRx, this));
+
+  Simulator::Run ();
+  Simulator::Destroy ();
+
+  NS_TEST_ASSERT_MSG_EQ (m_sent, 300000, "Sent the full 300000 bytes");
+  NS_TEST_ASSERT_MSG_EQ (m_received, 300000, "Received the full 300000 bytes");
+}
+
+class BulkSendTestSuite : public TestSuite
+{
+public:
+  BulkSendTestSuite ();
+};
+
+BulkSendTestSuite::BulkSendTestSuite ()
+  : TestSuite ("bulk-send-application", UNIT)
+{
+  AddTestCase (new BulkSendBasicTestCase, TestCase::QUICK);
+  AddTestCase (new BulkSendSeqTsSizeTestCase, TestCase::QUICK);
+}
+
+static BulkSendTestSuite g_bulkSendTestSuite;
+
